clc
clear all
close all

Xopt = dlmread('../results/outputPropagatedSamplesOptimalControl.txt');
Xfab = dlmread('../results/outputPropagatedSamplesFABLE.txt');

ns = 5;
nt = size(Xopt,2)/(ns+1);
nSamples = size(Xopt,1)-2;

initialMean = Xopt(1,1:ns);
initialSigma = Xopt(1,ns+1:2*ns);
initialLB = initialMean-initialSigma;
initialUB = initialMean+initialSigma;
finalMean = Xopt(2,1:ns);
finalSigma = Xopt(2,ns+1:2*ns);
finalSigma./abs(finalMean)



XFopt = Xopt(3:end,end-5:end);
XFfab = Xfab(3:end,end-5:end);

XTopt = {};
XTfab = {};
for i = 1:nSamples
    XTopt{i} = [];
    XTfab{i} = [];
    for j = 1:nt
        XTopt{i} = [XTopt{i}; Xopt(i+2,6*j-5:6*j)];
        XTfab{i} = [XTfab{i}; Xfab(i+2,6*j-5:6*j)];
        
        % Scale
%         XTopt{i}(j,2:end) = XTopt{i}(j,2:end)*180/pi;
%         XTfab{i}(j,2:end) = XTfab{i}(j,2:end)*180/pi;
    end
end

% % Scale in rad
% finalMean(2:end) = finalMean(2:end)*180/pi;
% finalSigma(2:end) = finalSigma(2:end)*180/pi;
% XFopt(:,2:end) = XFopt(:,2:end)*180/pi;
% XFfab(:,2:end) = XFfab(:,2:end)*180/pi;

clear Xopt Xfab;

% Plot of initial set projection on variables i and j
% Generate initial box
% for i = 1:ns-1
%    for j = i+1:ns-1
%
%        figure
%        hold on
%        plot([initialLB(i) initialLB(i)],[initialLB(j) initialUB(j)],'r','Linewidth',5)
%        plot([initialUB(i) initialUB(i)],[initialLB(j) initialUB(j)],'r','Linewidth',5)
%        plot([initialLB(i) initialUB(i)],[initialLB(j) initialLB(j)],'r','Linewidth',5)
%        plot([initialLB(i) initialUB(i)],[initialUB(j) initialUB(j)],'r','Linewidth',5)
%        plot(X0(:,i),X0(:,j),'k*');
%        axis equal
%        hold off
%        if (i==1)
%            xlabel('a');
%        elseif (i==2)
%            xlabel('P1')
%        elseif (i==3)
%            xlabel('P2')
%        elseif (i==4)
%            xlabel('Q1')
%        elseif (i==5)
%            xlabel('Q2')
%        end
%        if (j==1)
%            ylabel('a');
%        elseif (j==2)
%            ylabel('P1')
%        elseif (j==3)
%            ylabel('P2')
%        elseif (j==4)
%            ylabel('Q1')
%        elseif (j==5)
%            ylabel('Q2')
%        end
%
%
%    end
% end



% Plot of final set projection on variables i and j
% Generate arrival ellipse
figure
hold on
pc = 1;

for i = 1:ns-1
    for j = i+1:ns-1
        
        subplot(3,2,pc);
        pc = pc+1;
        
        t = linspace(0,2*pi,1000);
        xEl = finalMean(i)+finalSigma(i).*cos(t);
        yEl = finalMean(j)+finalSigma(j).*sin(t);
        
        hold on
        plot(xEl,yEl,'b','LineWidth',3)
        plot(finalMean(i),finalMean(j)-finalSigma(j),'r*','Linewidth',5)
        plot(finalMean(i),finalMean(j)+finalSigma(j),'r*','Linewidth',5)
        plot(finalMean(i)-finalSigma(i),finalMean(j),'r*','Linewidth',5)
        plot(finalMean(i)+finalSigma(i),finalMean(j),'r*','Linewidth',5)
        plot(XFopt(:,i),XFopt(:,j),'k*')
        plot(XFfab(:,i),XFfab(:,j),'y*')
%         axis equal
        hold off
        if (i==1)
            xlabel('a [au]');
        elseif (i==2)
            xlabel('P1 [rad]')
        elseif (i==3)
            xlabel('P2 [rad]')
        elseif (i==4)
            xlabel('Q1 [rad]')
        elseif (i==5)
            xlabel('Q2 [rad]')
        end
        if (j==1)
            ylabel('a [au]');
        elseif (j==2)
            ylabel('P1 [rad]')
        elseif (j==3)
            ylabel('P2 [rad]')
        elseif (j==4)
            ylabel('Q1 [rad]')
        elseif (j==5)
            ylabel('Q2 [rad]')
        end
        
        
    end
end



%% Plot state evolution as function of L
% 
% figure
% title('State evolution')
% pc = 5;
% 
% for i = pc:pc
%     
% %     subplot(3,2,i);
%     hold on
%     for j = 1:nSamples
%         plot(XTopt{j}(:,6),XTopt{j}(:,i),'k')
%         plot(XTfab{j}(:,6),XTfab{j}(:,i),'y')
%     end
%     xlabel('L [rad]')
%     if (j==1)
%         ylabel('a [au]');
%     elseif (j==2)
%         ylabel('P1 [rad]')
%     elseif (j==3)
%         ylabel('P2 [rad]')
%     elseif (j==4)
%         ylabel('Q1 [rad]')
%     elseif (j==5)
%         ylabel('Q2 [rad]')
%     end
%     hold off
%     
% end


%% Final complying points
invSigma = zeros(ns,ns);
for i = 1:ns
    invSigma(i,i) = 1/finalSigma(i)^2;
end
nNonEllipsoidFab = 0;
nNonEllipsoidOpt = 0;
for i = 1:nSamples
    xfab = (XFfab(i,1:ns)-finalMean)';
    xopt = (XFopt(i,1:ns)-finalMean)';
    yfab = xfab'*invSigma*xfab;
    yopt = xopt'*invSigma*xopt;
    if (yfab>1)
        nNonEllipsoidFab = nNonEllipsoidFab+1;
    end
    if (yopt>1)
        nNonEllipsoidOpt = nNonEllipsoidOpt+1;
    end
end
disp(['percNonEllipsidFav = ' num2str(nNonEllipsoidFab/nSamples)])
disp(['percNonEllipsidOpt = ' num2str(nNonEllipsoidOpt/nSamples)])