if (NOT __SMART_ASTRO_INCLUDED) # guard against multiple includes
    set(__SMART_ASTRO_INCLUDED TRUE)

    # use the system-wide smart-astro if present
    find_package(smart-astro)
    if (SMART_ASTRO_FOUND)
        set(SMART_ASTRO_EXTERNAL FALSE)
    else ()

        # build directory
        set(smart-astro_PREFIX "${BUILD_PATH_BUILD}/external/src/smart-astro")
        # install directory
        set(smart-astro_INSTALL "${BUILD_PATH_BUILD}/external/install")

        ExternalProject_Add(smart-astro
                PREFIX ${smart-astro_PREFIX}
                INSTALL_DIR ${smart-astro_INSTALL}
                GIT_REPOSITORY "git@github.com:strath-ace-labs/smart-astro.git"
                GIT_TAG "cristian_development"
                CMAKE_ARGS -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE} -DBUILD_STATIC=ON
                -DCMAKE_INSTALL_PREFIX=${smart-astro_INSTALL}
                -DCMAKE_C_FLAGS=${GFLAGS_C_FLAGS}
                -DCMAKE_CXX_FLAGS=${GFLAGS_CXX_FLAGS}
                LOG_DOWNLOAD 1
                LOG_INSTALL 1)

        set(SMART_ASTRO_FOUND TRUE)
        set(SMART_ASTRO_INCLUDE_DIR "${smart-astro_INSTALL}/include/smart-astro/")
#        message(STATUS "${SMART_ASTRO_INCLUDE_DIR}")
        if (APPLE)
            set(SMART_ASTRO_LIBRARY "${smart-astro_INSTALL}/lib/smart-astro/libsmart-astro.dylib")
        else()
            set(SMART_ASTRO_LIBRARY "${smart-astro_INSTALL}/lib/smart-astro/libsmart-astro.so")
        endif()
        set(SMART_ASTRO_STATIC_LIBRARY "${smart-astro_INSTALL}/lib/smart-astro/libsmart-astro.a")
        set(SMART_ASTRO_EXTERNAL TRUE)
    endif ()
#    message(STATUS "SMART_ASTRO include directory: ${SMART_ASTRO_INCLUDE_DIR}")
endif ()