## NLOPT LIBRARY
find_path (NLOPT_INCLUDE_DIR
        NAMES  nlopt.h
        PATHS "/usr/local/include/nlopt/" )
mark_as_advanced (NLOPT_INCLUDE_DIR)

find_library (NLOPT_LIBRARY
        NAMES nlopt_cxx
        PATHS "/usr/local/lib/nlopt/" )
mark_as_advanced (NLOPT_LIBRARY)

include (FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS (NLOPT
        REQUIRED_VARS NLOPT_LIBRARY NLOPT_INCLUDE_DIR
        VERSION_VAR NLOPT_VERSION_STRING
        )

if (NLOPT_FOUND)

    # NLOPT
    set (NLOPT_LIBRARIES ${NLOPT_LIBRARY})
    set (NLOPT_INCLUDE_DIRS ${NLOPT_INCLUDE_DIR})

    # Add compiler flag
    add_definitions(-D__USE_NLOPT)

#    message(STATUS "NLOPT include directory: ${NLOPT_INCLUDE_DIRS}")
#    message(STATUS "NLOPT library: ${NLOPT_LIBRARIES}")

else()

    message( FATAL_ERROR "NLOPT not found")

endif()