if (NOT __WORHP_INCLUDED) # guard against multiple includes
    set(__WORHP_INCLUDED TRUE)

    # Add compiler flag
    add_definitions(-D__USE_WORHP)

    find_path (WORHP_INCLUDE_DIR
            NAMES worhp/worhp.h
            PATHS "/usr/include/" "/usr/include/worhp" "/usr/local/include/worhp" )
    mark_as_advanced (WORHP_INCLUDE_DIR)

    find_library (WORHP_LIBRARY
            NAMES worhp
            PATHS "/usr/lib/" "/usr/local/lib/worhp" )
    mark_as_advanced (WORHP_LIBRARY)

    if (WORHP_INCLUDE_DIR)
        if (EXISTS "${WORHP_INCLUDE_DIR}/worhp_version.h")
            file (STRINGS "${WORHP_INCLUDE_DIR}/worhp_version.h" _VERSION_LINE REGEX "WORHP_MAJOR")
            string (REGEX MATCH "([0-9]+)$" _VERSION_MAJOR ${_VERSION_LINE})

            file (STRINGS "${WORHP_INCLUDE_DIR}/worhp_version.h" _VERSION_LINE REGEX "WORHP_MINOR")
            string (REGEX MATCH "([0-9]+)$" _VERSION_MINOR ${_VERSION_LINE})

            file (STRINGS "${WORHP_INCLUDE_DIR}/worhp_version.h" _VERSION_LINE REGEX "WORHP_PATCH")
            string (REGEX MATCH "([0-9]+)$" _VERSION_PATCH ${_VERSION_LINE})

            set (WORHP_VERSION_STRING "${_VERSION_MAJOR}.${_VERSION_MINOR}.${_VERSION_PATCH}")
            unset (_VERSION_MAJOR)
            unset (_VERSION_MINOR)
            unset (_VERSION_PATCH)
            unset (_VERSION_LINE)
        endif()
    endif()

    include (FindPackageHandleStandardArgs)
    FIND_PACKAGE_HANDLE_STANDARD_ARGS (WORHP
            REQUIRED_VARS WORHP_LIBRARY WORHP_INCLUDE_DIR
            VERSION_VAR WORHP_VERSION_STRING
            )

    if (WORHP_FOUND)
        set (WORHP_LIBRARIES ${WORHP_LIBRARY})
        set (WORHP_INCLUDE_DIRS ${WORHP_INCLUDE_DIR})
    endif()
#    message(STATUS "WORHP include directory: ${WORHP_INCLUDE_DIR}")
endif()