/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2018 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#include "propagatorSurrogate.h"

using namespace ipanema;
using namespace propagatorSurrogates;

/**
 * Constructor and Destructor
 */

// Default constructor
propagatorSurrogate::propagatorSurrogate()
{
    // Sanity check
    inputParamsSanityCheck();
}

// Default destructor
propagatorSurrogate::~propagatorSurrogate()
{
    // Nothing here
}

// Evaluate the surrogate
std::vector<double> propagatorSurrogate::propagate (const std::vector<double>& x) const
{
    ipanema_throw("Shall be re-implemented");
}

// Build the surrogate
void propagatorSurrogate::build()
{
    ipanema_throw("Shall be re-implemented");
}

// Sanity checks on input parameters
void propagatorSurrogate::inputParamsSanityCheck() const
{
    // Nothing for now
}