/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2018 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#include "samplingConstraints.h"

using namespace ipanema;
using namespace ipanemaConstraints;


/**
 * Constructor and Destructor
 */

// Default constructor
samplingConstraints::samplingConstraints(const samplingConstraintsParams* pParams)
        : m_pParams(pParams)
{
    // Nothing here
}

// Default destructor
samplingConstraints::~samplingConstraints()
{
    // Nothing here
}



/**
 * List of virtual functions to be implemented in derived classes
 */

// Evaluate the constraint in pSamples
double samplingConstraints::evaluate ()
{
    ipanema_throw("To be re-implemented in derived class");
}