/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2017 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#ifndef IPANEMA_EXCEPTION_H
#define IPANEMA_EXCEPTION_H

#include <exception>
#include <cassert>
#include <iostream>
#include <string>

#define _IPANEMA_EXCEPTION_QUOTEME(x) #x
#define IPANEMA_EXCEPTION_QUOTEME(x) _IPANEMA_EXCEPTION_QUOTEME(x)
#define IPANEMA_EXCEPTION_EXCTOR(s) ((std::string(__FILE__ "," IPANEMA_EXCEPTION_QUOTEME(__LINE__) ": ") + s) + ".")
#define IPANEMA_EX_THROW(s) (throw IPANEMA_EXCEPTION(IPANEMA_EXCEPTION_EXCTOR(s)))

#define ipanema_throw(s) IPANEMA_EX_THROW(s)

namespace ipanema{
    class IPANEMA_EXCEPTION: public std::exception {
    public:
        IPANEMA_EXCEPTION(const std::string &s):m_what(s) {}
        virtual const char *what() const throw() {
            return m_what.c_str();
        }
        virtual ~IPANEMA_EXCEPTION() throw() {}
    protected:
        std::string m_what;
    };
} // namespace ipanema

#endif //IPANEMA_EXCEPTION_H
