/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2018 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#include "deterministicObjectives.h"

using namespace ipanema;
using namespace ipanemaObjectives;


/**
 * Constructor and Destructor
 */


// Default constructor
deterministicObjectives::deterministicObjectives(const deterministicObjectivesParams* pParams) :
        m_pParams(pParams)
{
    // Nothing here
}


// Default destructor
deterministicObjectives::~deterministicObjectives()
{
    // Nothing here
}


/**
 * List of virtual functions to be implemented in this derived classes
 */

// Evaluate the objective according to quantities in params
double deterministicObjectives::evaluate ()
{
    ipanema_throw("It will be implemented in derived classes");
}
