/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2018 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#ifndef IPANEMA_DETERMINISTICOBJECTIVES_H
#define IPANEMA_DETERMINISTICOBJECTIVES_H

#include <vector>
#include <cmath>

#include "../ipanemaException.h"

namespace ipanema
{
namespace ipanemaObjectives
{

    class deterministicObjectives {


        /**
         * Parameter struct
         */

    public:

        struct deterministicObjectivesParams {

            // Nothin here yet

        };



        /**
         * Class members
         */

    protected:

        const deterministicObjectivesParams* m_pParams;



        /**
         * Constructor and Destructor
         */

    public:

        // Default constructor
        deterministicObjectives(const deterministicObjectivesParams* pParams);

        // Default destructor
        virtual ~deterministicObjectives();



        /**
         * List of virtual functions to be implemented in derived classes
         */

    public:

        // Evaluate the objective according to quantities in params
        virtual double evaluate ();



        /**
         * List of private help functions to better organise the code
         */

    private:


    };


} // namespace ipanemaObjectives
} // namespace ipanema


#endif //IPANEMA_DETERMINISTICOBJECTIVES_H
