/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
/*
------ Copyright (C) 2018 University of Strathclyde and Authors ------
-------------------- e-mail: c.greco@strath.ac.uk --------------------
----------------------- Author: Cristian Greco -----------------------
*/

#ifndef IPANEMA_UTILS_H
#define IPANEMA_UTILS_H

#include <vector>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>

#include "../ipanemaException.h"

namespace ipanema
{

    /**
     * Function to read from file
     */
    int dlmread ( const std::string &file_name,
                  std::vector<std::vector<double>>& output,
                  const char& delim = ' ');

    /**
     * Function to write to file
     */
    int dlmwrite ( const std::string &file_name,
                   const std::vector<std::vector<double>> &output,
                   const unsigned int &precision = 10 ,
                   const std::string &delimiter = " ");


} // namespace ipanema

#endif //IPANEMA_UTILS_H
